package nc.ui.gl.assattributedetail;

import java.awt.BorderLayout;
import java.awt.Insets;
import java.awt.LayoutManager;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.Date;
import java.util.Vector;
import javax.swing.JFrame;
import nc.bs.logging.Logger;
import nc.itf.gl.accbook.IBillModel;
import nc.ui.bd.CorpBO_Client;
import nc.ui.gl.accbook.PrintDialog;
import nc.ui.gl.accbook.TableDataModel;
import nc.ui.gl.assattributebanlance.QryDlg;
import nc.ui.gl.assattributedetail.AssDetailUI;
import nc.ui.gl.assattributedetail.ButtonKey;
import nc.ui.gl.assattributedetail.DetailList;
import nc.ui.gl.pubvoucher.VoucherBridge;
import nc.ui.glpub.IParent;
import nc.ui.ml.NCLangRes;
import nc.ui.pub.ClientEnvironment;
import nc.ui.pub.beans.UIDialogEvent;
import nc.ui.pub.beans.UIDialogListener;
import nc.ui.pub.beans.UIPanel;
import nc.ui.pub.print.IDataSource;
import nc.ui.pub.print.PrintDirectEntry;
import nc.ui.pub.print.datastruct.CellRange;
import nc.vo.gl.accbook.ColFormatVO;
import nc.vo.gl.detailbooks.DetailBSVO;
import nc.vo.glcom.balance.GlQueryVO;

public class AssDetailView extends UIPanel implements UIDialogListener, IDataSource {

   private IParent iParent;
   private QryDlg ivjQryDlg = null;
   private GlQueryVO qryVO;
   private DetailList dataList = new DetailList();
   private AssDetailUI ivjAssDetailUI = null;
   private IBillModel billModel = null;
   private VoucherBridge m_VoucherBridge;
   private PrintDialog printDlg = null;


   public AssDetailView() {
      this.initialize();
   }

   public AssDetailView(LayoutManager p0) {
      super(p0);
   }

   public AssDetailView(LayoutManager p0, boolean p1) {
      super(p0, p1);
   }

   public AssDetailView(boolean p0) {
      super(p0);
   }

   public void dialogClosed(UIDialogEvent event) {
      if(event.getSource() == this.ivjQryDlg) {
         if(event.m_Operation == 202) {
            return;
         }

         if(event.m_Operation == 204) {
            this.ivjQryDlg.getResult();
            this.qryVO = this.ivjQryDlg.getqryVO();
            if(this.qryVO == null) {
               return;
            }

            this.setQryVO((GlQueryVO)this.qryVO.clone());
         }
      }

   }

   public void firstPage() throws Exception {
      if(this.qryVO != null) {
         TableDataModel data;
         for(data = (TableDataModel)this.dataList.first(); !this.dataList.isEnd() && data.getData().length == 0; data = (TableDataModel)this.dataList.next()) {
            ;
         }

         this.getAssDetailUI().setTableData(data, this.dataList.getQueryVO());
      }
   }

   public String[] getAllDataItemExpress() {
      return null;
   }

   public String[] getAllDataItemNames() {
      return null;
   }

   private AssDetailUI getAssDetailUI() {
      if(this.ivjAssDetailUI == null) {
         try {
            this.ivjAssDetailUI = new AssDetailUI();
            this.ivjAssDetailUI.setName("AssDetailUI");
         } catch (Throwable var2) {
            this.handleException(var2);
         }
      }

      return this.ivjAssDetailUI;
   }

   public IBillModel getBillModel() {
      return this.billModel;
   }

   public String[] getDependentItemExpressByExpress(String itemName) {
      return null;
   }

   public IParent getIParent() {
      return this.iParent;
   }

   public String[] getItemValuesByExpress(String itemExpress) {
      return null;
   }

   public String getModuleName() {
      return null;
   }

   public PrintDialog getPrintDlg() {
      return this.printDlg;
   }

   private QryDlg getQryDlg() {
      if(this.ivjQryDlg == null) {
         try {
            this.ivjQryDlg = new QryDlg();
            this.ivjQryDlg.setName("QryDlg");
            this.ivjQryDlg.setDefaultCloseOperation(2);
            this.ivjQryDlg.addUIDialogListener(this);
         } catch (Throwable var2) {
            this.handleException(var2);
         }
      }

      return this.ivjQryDlg;
   }

   public GlQueryVO getQryVO() {
      return this.qryVO;
   }

   private void handleException(Throwable exception) {
   }

   private void initialize() {
      try {
         this.setName("AssDetailView");
         this.setLayout(new BorderLayout());
         this.setSize(790, 558);
         this.add(this.getAssDetailUI(), "Center");
      } catch (Throwable var2) {
         this.handleException(var2);
      }

      this.dataList.setBillModel(this.billModel);
   }

   public boolean isNumber(String itemExpress) {
      return false;
   }

   public void lastPage() throws Exception {
      if(this.qryVO != null) {
         TableDataModel data;
         for(data = (TableDataModel)this.dataList.last(); !this.dataList.isStart() && data.getData().length == 0; data = (TableDataModel)this.dataList.prev()) {
            ;
         }

         this.getAssDetailUI().setTableData(data, this.dataList.getQueryVO());
      }
   }

   public static void main(String[] args) {
      try {
         JFrame exception = new JFrame();
         AssDetailView aAssDetailView = new AssDetailView();
         exception.setContentPane(aAssDetailView);
         exception.setSize(aAssDetailView.getSize());
         exception.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
               System.exit(0);
            }
         });
         exception.show();
         Insets insets = exception.getInsets();
         exception.setSize(exception.getWidth() + insets.left + insets.right, exception.getHeight() + insets.top + insets.bottom);
         exception.setVisible(true);
      } catch (Throwable var4) {
         System.err.println("nc.ui.pub.beans.UIPanel 的 main() 中发生异常");
         var4.printStackTrace(System.out);
      }

   }

   public void nextPage() throws Exception {
      if(this.qryVO != null) {
         TableDataModel data;
         for(data = (TableDataModel)this.dataList.next(); !this.dataList.isEnd() && data.getData().length == 0; data = (TableDataModel)this.dataList.next()) {
            ;
         }

         this.getAssDetailUI().setTableData(data, this.dataList.getQueryVO());
      }
   }

   public void prevPage() throws Exception {
      if(this.qryVO != null) {
         TableDataModel data;
         for(data = (TableDataModel)this.dataList.prev(); !this.dataList.isStart() && data.getData().length == 0; data = (TableDataModel)this.dataList.prev()) {
            ;
         }

         this.getAssDetailUI().setTableData(data, this.dataList.getQueryVO());
      }
   }

   private void print() throws Exception {
      PrintDirectEntry printEntry = new PrintDirectEntry(this);
      printEntry.setTitle(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000295"));
      ColFormatVO[] formats = this.getAssDetailUI().getAssFixTableModel().getFormatVO().getColFormatVOs();
      Vector vLine1 = new Vector();
      Vector vLine0 = new Vector();
      Vector align = new Vector();
      Vector vColWidths = new Vector();
      int fixCol = 0;

      for(int line1 = 0; line1 < formats.length; ++line1) {
         if(formats[line1].isVisiablity()) {
            vLine0.add(formats[line1].getMultiHeadStr() == null?formats[line1].getColName():formats[line1].getMultiHeadStr());
            vLine1.add(formats[line1].getColName());
            vColWidths.add(new Integer(formats[line1].getColWidth()));
            if(formats[line1].getAlignment() == 2) {
               align.add(new Integer(0));
            } else if(formats[line1].getAlignment() == 0) {
               align.add(new Integer(1));
            } else if(formats[line1].getAlignment() == 4) {
               align.add(new Integer(2));
            }

            if(formats[line1].isFrozen()) {
               ++fixCol;
            }
         }
      }

      String[] var27 = new String[vLine1.size()];
      String[] line0 = new String[vLine0.size()];
      int[] iAlignFlag = new int[var27.length];

      for(int colWidth = 0; colWidth < iAlignFlag.length; ++colWidth) {
         iAlignFlag[colWidth] = ((Integer)align.elementAt(colWidth)).intValue();
      }

      int[] var28 = new int[vColWidths.size()];

      for(int colNames = 0; colNames < var28.length; ++colNames) {
         var28[colNames] = ((Integer)vColWidths.elementAt(colNames)).intValue();
      }

      vLine1.copyInto(var27);
      vLine0.copyInto(line0);
      String[][] var29 = new String[][]{line0, var27};
      printEntry.setColNames(var29);
      printEntry.setAlignFlag(iAlignFlag);
      String[][] sTop = new String[3][1];
      sTop[0][0] = NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000296") + this.getAssDetailUI().getlbQryInfo().getText();
      sTop[1][0] = NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000071") + this.getAssDetailUI().getlbPeriod().getText();
      sTop[2][0] = NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000297") + CorpBO_Client.getCorpNames(this.getQryVO().getPk_corp())[0];
      printEntry.setTopStr(sTop);
      printEntry.setTopStrFixed(true);
      printEntry.setFixedRows(2);
      printEntry.setTopStrColRange(new int[]{var27.length - 1, var27.length - 1});
      String[][] sBottom = new String[3][1];
      sBottom[0][0] = NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000172") + ClientEnvironment.getInstance().getCorporation().getUnitname();
      sBottom[1][0] = NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000173") + ClientEnvironment.getInstance().getUser().getUserName();
      sBottom[2][0] = NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000174") + (new Date()).toLocaleString();
      printEntry.setBottomStr(sBottom);
      printEntry.setBottomStrFixed(true);
      printEntry.setBStrColRange(new int[]{var27.length - 1});
      Vector vRange = new Vector();

      int startCol;
      for(startCol = 0; startCol < line0.length; ++startCol) {
         if(line0[startCol].equals(var27[startCol])) {
            CellRange endCol = new CellRange(0, startCol, 1, startCol);
            vRange.add(endCol);
         }
      }

      startCol = 0;
      int var30 = 0;
      boolean flag = false;

      while(startCol < line0.length) {
         flag = startCol != var30;
         if(var30 < line0.length && line0[startCol].equals(line0[var30])) {
            if(startCol < line0.length - 1) {
               ++var30;
            } else {
               ++startCol;
            }
         } else if(flag) {
            if(var30 - startCol != 1) {
               CellRange range = new CellRange(0, startCol, 0, var30 - 1);
               vRange.add(range);
            }

            startCol = var30;
         }
      }

      CellRange[] var31 = new CellRange[vRange.size()];
      vRange.copyInto(var31);
      printEntry.setCombinCellRange(var31);
      printEntry.setMargin(10, 10, 10, 10);
      int[] lineHeight = new int[this.getAssDetailUI().getAssFixTableModel().getRowCount() + 2];
      lineHeight[0] = 15;
      lineHeight[1] = 15;

      for(int data = 0; data < this.getAssDetailUI().getAssFixTableModel().getRowCount(); ++data) {
         lineHeight[data + 2] = 15;
      }

      printEntry.setRowHeight(lineHeight);
      Object[][] var32 = new Object[this.getAssDetailUI().getAssFixTableModel().getRowCount()][var27.length];
      int[] location = new int[var27.length - this.getAssDetailUI().getAssFixTableModel().getColumnCount()];
      int index = 0;

      int i;
      for(i = 0; i < this.getAssDetailUI().getTableModel().getColumnCount(); ++i) {
         if(formats[i + this.getAssDetailUI().getAssFixTableModel().getColumnCount()].isVisiablity()) {
            location[index] = i;
            ++index;
         }
      }

      for(i = 0; i < this.getAssDetailUI().getAssFixTableModel().getRowCount(); ++i) {
         int iIndex;
         for(iIndex = 0; iIndex < this.getAssDetailUI().getAssFixTableModel().getColumnCount(); ++iIndex) {
            var32[i][iIndex] = this.getAssDetailUI().getAssFixTableModel().getValueAt(i, iIndex);
         }

         iIndex = 0;

         for(int j = this.getAssDetailUI().getAssFixTableModel().getColumnCount(); j < var27.length; ++j) {
            var32[i][j] = this.getAssDetailUI().getTableModel().getValueAt(i, location[iIndex]);
            ++iIndex;
         }
      }

      printEntry.setData(var32);
      printEntry.setPageNumDisp(true);
      printEntry.setPageNumAlign(2);
      printEntry.setFixedCols(fixCol);
      Logger.debug("-------------" + fixCol + "------------------");
      printEntry.setColWidth(var28);
      printEntry.preview();
   }

   public void setBillModel(IBillModel newBillModel) {
      this.billModel = newBillModel;
   }

   public void setIParent(IParent newIParent) {
      this.iParent = newIParent;
   }

   public void setPrintDlg(PrintDialog newPrintDlg) {
      this.printDlg = newPrintDlg;
   }

   public void setQryVO(GlQueryVO newQryVO) {
      try {
         this.qryVO = newQryVO;
         this.dataList.setBillModel(this.billModel);
         this.dataList.setQueryVO(newQryVO);
         this.firstPage();
      } catch (Exception var3) {
         var3.printStackTrace();
      }

   }

   public void tackleBnsEvent(String bnTag) throws Exception {
      if(bnTag.equals(ButtonKey.bnQRY)) {
         this.getQryDlg().showModal();
      } else if(bnTag.equals(ButtonKey.bnNext)) {
         this.nextPage();
      } else if(bnTag.equals(ButtonKey.bnPriv)) {
         this.prevPage();
      } else if(bnTag.equals(ButtonKey.bnFirst)) {
         this.firstPage();
      } else if(bnTag.equals(ButtonKey.bnEnd)) {
         this.lastPage();
      } else if(bnTag.equals(ButtonKey.bnPrint)) {
         this.print();
      } else if(!bnTag.equals(ButtonKey.bnLC) && !bnTag.equals(nc.ui.gl.diarybooks.ButtonKey.bnVoucher)) {
         if(bnTag.equals(ButtonKey.bnReturn)) {
            this.iParent.closeMe();
         }
      } else {
         DetailBSVO[] voData = (DetailBSVO[])((DetailBSVO[])this.dataList.getCurrentData());
         int iCurrent = this.getAssDetailUI().getSelectedRow();
         if(iCurrent < 0) {
            return;
         }

         if(voData[iCurrent].getValue(44) == null) {
            return;
         }

         if(voData[iCurrent].getValue(2) == null || voData[iCurrent].getValue(2).equals("")) {
            return;
         }

         if(this.m_VoucherBridge == null) {
            this.m_VoucherBridge = (VoucherBridge)this.iParent.showNext("nc.ui.gl.pubvoucher.VoucherBridge", new Integer[]{new Integer(2)});
         } else {
            this.iParent.showNext(this.m_VoucherBridge);
         }

         this.m_VoucherBridge.setVoucherPk((String)voData[iCurrent].getValue(44));
      }

   }
}
